MODULE IdRng;

IMPORT IO, Lib;

CONST
  cnt = 2;

TYPE
  TId = CARDINAL;
  TIds = ARRAY [0..cnt-1] OF TId;

CONST
  ids = TIds{ 10, 20 };


PROCEDURE ChkMon();
VAR
  n: CARDINAL;
  x: TId;
BEGIN
  IF cnt < 2 THEN RETURN END;
  n := cnt - 1;
  x := ids[ n ];
  WHILE n > 0 DO
    DEC( n );
    IF x <= ids[ n ] THEN Lib.FatalError( 'ChkMon failed' ) END;
  END;
END ChkMon;


PROCEDURE Find( x: TId ): CARDINAL;
VAR i, j, m: CARDINAL;
BEGIN
  i := 0; j := cnt;
  WHILE i < j DO
    m := ( i + j ) DIV 2;
    IF ids[ m ] <= x THEN i := m + 1 ELSE j := m END;
  END;
  (* i = j; ids[i-1] <= x < ids[i] *)
  RETURN i;
END Find;

PROCEDURE InRng( x: TId ): BOOLEAN;
BEGIN
  RETURN ODD( Find( x ) );
END InRng;

PROCEDURE Show( x: TId );
BEGIN
  IO.WrCard( x, 2 );
  IO.WrStr( ' -> ' );
  IO.WrCard( Find(x), 1 );
  IO.WrLn();
END Show;

PROCEDURE Show2( x: TId );
BEGIN
  IO.WrCard( x, 2 );
  IO.WrStr( ' -> ' );
  IO.WrCard( ORD( InRng(x) ), 1 );
  IO.WrLn();
END Show2;

PROCEDURE Show0();
VAR i: CARDINAL;
BEGIN
  IO.WrStr( 'ids = { ' );
  FOR i := 0 TO cnt - 1 DO
    IO.WrCard( ids[i], 1 );
    IF i < cnt - 1 THEN IO.WrStr( ', ' ); END;
  END;
  IO.WrStr( ' }' );
  IO.WrLn();
END Show0;

BEGIN
  ChkMon();
  Show0();
  Show2( 0 );
  Show2( 9 );
  Show2( 10 );
  Show2( 11 );
  Show2( 19 );
  Show2( 20 );
  Show2( 21 );
END IdRng.
